import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkOrderInfoLog, ThinkOrderInfoLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkOrderInfoLog(params: ThinkOrderInfoLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkOrderInfoLog>>>(
    THINK_API_URL + '/think/think-order-info-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkOrderInfoLog(params?: ThinkOrderInfoLogParam) {
  const res = await request.get<ApiResult<ThinkOrderInfoLog[]>>(
    THINK_API_URL + '/think/think-order-info-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkOrderInfoLog(data: ThinkOrderInfoLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkOrderInfoLog(data: ThinkOrderInfoLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkOrderInfoLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkOrderInfoLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkOrderInfoLog(id: number) {
  const res = await request.get<ApiResult<ThinkOrderInfoLog>>(
    THINK_API_URL + '/think/think-order-info-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
